# This file automatically generated by skymarshal
# DO NOT MODIFY BY HAND
# fmt: off
# isort: off
# mypy: disallow-untyped-defs
#
# From Source File: /Users/runner/work/symforce/symforce/lcmtypes/symforce.lcm

import copy
import typing as T  # pylint: disable=unused-import

from io import BytesIO
import struct
from lcmtypes.eigen_lcm._Vector3d import Vector3d

class imu_biases_t(object):
    __slots__: T.List[str] = ["accel_bias", "gyro_bias"]

    def __init__(
        self,
        accel_bias: T.Optional[Vector3d]=None,
        gyro_bias: T.Optional[Vector3d]=None,
        _skip_initialize: bool=False,
    ) -> None:
        """ If _skip_initialize is True, all other constructor arguments are ignored """
        if _skip_initialize:
            return
        self.accel_bias: Vector3d = Vector3d._default() if accel_bias is None else accel_bias
        self.gyro_bias: Vector3d = Vector3d._default() if gyro_bias is None else gyro_bias

    @staticmethod
    def from_all_fields(
        accel_bias: Vector3d,
        gyro_bias: Vector3d,
    ) -> "imu_biases_t":
        return imu_biases_t(
            accel_bias=accel_bias,
            gyro_bias=gyro_bias,
        )

    @staticmethod
    def _skytype_meta() -> T.Dict[str, str]:
        return dict(
            type="struct",
            package="sym",
            name="imu_biases_t",
        )

    @classmethod
    def _default(cls) -> "imu_biases_t":
        return cls()

    def __repr__(self) -> str:
        return "imu_biases_t({})".format(
            ", ".join("{}={}".format(name, repr(getattr(self, name))) for name in self.__slots__))

    def __eq__(self, other: object) -> bool:
        if not isinstance(other, imu_biases_t):
            return NotImplemented
        return (
            (self.accel_bias==other.accel_bias) and
            (self.gyro_bias==other.gyro_bias)
        )
    # Disallow hashing for python struct lcmtypes.
    __hash__ = None  # type: ignore[assignment]

    def encode(self) -> bytes:
        buf = BytesIO()
        buf.write(imu_biases_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf: T.BinaryIO) -> None:
        if hasattr(self.accel_bias, '_get_packed_fingerprint'):
            assert self.accel_bias._get_packed_fingerprint() == Vector3d._get_packed_fingerprint()
        else:
            assert self.accel_bias._get_hash_recursive([]) == Vector3d._get_hash_recursive([])
        self.accel_bias._encode_one(buf)
        if hasattr(self.gyro_bias, '_get_packed_fingerprint'):
            assert self.gyro_bias._get_packed_fingerprint() == Vector3d._get_packed_fingerprint()
        else:
            assert self.gyro_bias._get_hash_recursive([]) == Vector3d._get_hash_recursive([])
        self.gyro_bias._encode_one(buf)

    @staticmethod
    def decode(data: T.Union[bytes, T.BinaryIO]) -> "imu_biases_t":
        # NOTE(eric): This function can technically accept either a BinaryIO or
        # anything that supports the C++ Buffer Protocol,
        # which is unspecifiable in type hints.

        if hasattr(data, "read"):
            # NOTE(eric): mypy isn't able to figure out the hasattr check
            buf = T.cast(T.BinaryIO, data)
        else:
            buf = BytesIO(T.cast(bytes, data))

        if buf.read(8) != imu_biases_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return imu_biases_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf: T.BinaryIO) -> "imu_biases_t":
        self = imu_biases_t(_skip_initialize=True)
        self.accel_bias = Vector3d._decode_one(buf)
        self.gyro_bias = Vector3d._decode_one(buf)
        return self

    @staticmethod
    def _get_hash_recursive(parents: T.List[T.Type]) -> int:
        if imu_biases_t in parents: return 0
        newparents = parents + [imu_biases_t]
        tmphash = (0x176ba7d50765eac2+ Vector3d._get_hash_recursive(newparents)+ Vector3d._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash

    _packed_fingerprint: T.Optional[bytes] = None

    @staticmethod
    def _get_packed_fingerprint() -> bytes:
        if imu_biases_t._packed_fingerprint is None:
            imu_biases_t._packed_fingerprint = struct.pack(">Q", imu_biases_t._get_hash_recursive([]))
        return imu_biases_t._packed_fingerprint

    def deepcopy(self, **kwargs: T.Any) -> "imu_biases_t":
        """
        Deep copy of this LCM type

        Returns a copy w/ members specified by kwargs replaced with new values specified by kwargs.
        """
        result = copy.deepcopy(self)
        for key in kwargs:
            if not hasattr(result, key):
                raise KeyError("Type imu_biases_t does not have attribute: " + str(key))
            setattr(result, key, kwargs[key])
        return result
