# This file automatically generated by skymarshal
# DO NOT MODIFY BY HAND
# fmt: off
# isort: off
# mypy: disallow-untyped-defs
#
# From Source File: /Users/runner/work/symforce/symforce/lcmtypes/symforce.lcm

import copy
import typing as T  # pylint: disable=unused-import

from io import BytesIO
import struct
from lcmtypes.sym._key_t import key_t
from lcmtypes.sym._type_t import type_t

class index_entry_t(object):
    __slots__: T.List[str] = ["key", "type", "offset", "storage_dim", "tangent_dim"]

    def __init__(
        self,
        key: T.Optional[key_t]=None,
        type: T.Optional[type_t]=None,
        offset: int=0,
        storage_dim: int=0,
        tangent_dim: int=0,
        _skip_initialize: bool=False,
    ) -> None:
        """ If _skip_initialize is True, all other constructor arguments are ignored """
        if _skip_initialize:
            return
        self.key: key_t = key_t._default() if key is None else key
        self.type: type_t = type_t._default() if type is None else type
        # Location within the storage or tangent vector, depending on context
        self.offset: int = offset
        # Size parameters
        self.storage_dim: int = storage_dim
        self.tangent_dim: int = tangent_dim

    @staticmethod
    def from_all_fields(
        key: key_t,
        type: type_t,
        offset: int,
        storage_dim: int,
        tangent_dim: int,
    ) -> "index_entry_t":
        return index_entry_t(
            key=key,
            type=type,
            offset=offset,
            storage_dim=storage_dim,
            tangent_dim=tangent_dim,
        )

    @staticmethod
    def _skytype_meta() -> T.Dict[str, str]:
        return dict(
            type="struct",
            package="sym",
            name="index_entry_t",
        )

    @classmethod
    def _default(cls) -> "index_entry_t":
        return cls()

    def __repr__(self) -> str:
        return "index_entry_t({})".format(
            ", ".join("{}={}".format(name, repr(getattr(self, name))) for name in self.__slots__))

    def __eq__(self, other: object) -> bool:
        if not isinstance(other, index_entry_t):
            return NotImplemented
        return (
            (self.key==other.key) and
            (self.type==other.type) and
            (self.offset==other.offset) and
            (self.storage_dim==other.storage_dim) and
            (self.tangent_dim==other.tangent_dim)
        )
    # Disallow hashing for python struct lcmtypes.
    __hash__ = None  # type: ignore[assignment]

    def encode(self) -> bytes:
        buf = BytesIO()
        buf.write(index_entry_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf: T.BinaryIO) -> None:
        if hasattr(self.key, '_get_packed_fingerprint'):
            assert self.key._get_packed_fingerprint() == key_t._get_packed_fingerprint()
        else:
            assert self.key._get_hash_recursive([]) == key_t._get_hash_recursive([])
        self.key._encode_one(buf)
        if hasattr(self.type, '_get_packed_fingerprint'):
            assert self.type._get_packed_fingerprint() == type_t._get_packed_fingerprint()
        else:
            assert self.type._get_hash_recursive([]) == type_t._get_hash_recursive([])
        self.type._encode_one(buf)
        buf.write(index_entry_t._CACHED_STRUCT_0.pack(self.offset, self.storage_dim, self.tangent_dim))

    @staticmethod
    def decode(data: T.Union[bytes, T.BinaryIO]) -> "index_entry_t":
        # NOTE(eric): This function can technically accept either a BinaryIO or
        # anything that supports the C++ Buffer Protocol,
        # which is unspecifiable in type hints.

        if hasattr(data, "read"):
            # NOTE(eric): mypy isn't able to figure out the hasattr check
            buf = T.cast(T.BinaryIO, data)
        else:
            buf = BytesIO(T.cast(bytes, data))

        if buf.read(8) != index_entry_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return index_entry_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf: T.BinaryIO) -> "index_entry_t":
        self = index_entry_t(_skip_initialize=True)
        self.key = key_t._decode_one(buf)
        self.type = type_t._decode_one(buf)
        self.offset, self.storage_dim, self.tangent_dim = index_entry_t._CACHED_STRUCT_0.unpack(buf.read(12))
        return self

    @staticmethod
    def _get_hash_recursive(parents: T.List[T.Type]) -> int:
        if index_entry_t in parents: return 0
        newparents = parents + [index_entry_t]
        tmphash = (0xf55e0465bf8566a5+ key_t._get_hash_recursive(newparents)+ type_t._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash

    _packed_fingerprint: T.Optional[bytes] = None

    @staticmethod
    def _get_packed_fingerprint() -> bytes:
        if index_entry_t._packed_fingerprint is None:
            index_entry_t._packed_fingerprint = struct.pack(">Q", index_entry_t._get_hash_recursive([]))
        return index_entry_t._packed_fingerprint

    def deepcopy(self, **kwargs: T.Any) -> "index_entry_t":
        """
        Deep copy of this LCM type

        Returns a copy w/ members specified by kwargs replaced with new values specified by kwargs.
        """
        result = copy.deepcopy(self)
        for key in kwargs:
            if not hasattr(result, key):
                raise KeyError("Type index_entry_t does not have attribute: " + str(key))
            setattr(result, key, kwargs[key])
        return result

    _CACHED_STRUCT_0 = struct.Struct(">iii")
