# This file automatically generated by skymarshal
# DO NOT MODIFY BY HAND
# fmt: off
# isort: off
# mypy: disallow-untyped-defs
#
# From Source File: /Users/runner/work/symforce/symforce/lcmtypes/symforce.lcm

import copy
import typing as T  # pylint: disable=unused-import

from io import BytesIO
import struct
from lcmtypes.sym._index_entry_t import index_entry_t

class index_t(object):
    __slots__: T.List[str] = ["storage_dim", "tangent_dim", "entries"]

    def __init__(
        self,
        storage_dim: int=0,
        tangent_dim: int=0,
        entries: T.Optional[T.List[index_entry_t]]=None,
        _skip_initialize: bool=False,
    ) -> None:
        """ If _skip_initialize is True, all other constructor arguments are ignored """
        if _skip_initialize:
            return
        self.storage_dim: int = storage_dim
        self.tangent_dim: int = tangent_dim
        self.entries: T.List[index_entry_t] = [] if entries is None else entries

    @staticmethod
    def from_all_fields(
        storage_dim: int,
        tangent_dim: int,
        entries: T.List[index_entry_t],
    ) -> "index_t":
        return index_t(
            storage_dim=storage_dim,
            tangent_dim=tangent_dim,
            entries=entries,
        )

    @staticmethod
    def _skytype_meta() -> T.Dict[str, str]:
        return dict(
            type="struct",
            package="sym",
            name="index_t",
        )

    @classmethod
    def _default(cls) -> "index_t":
        return cls()

    def __repr__(self) -> str:
        return "index_t({})".format(
            ", ".join("{}={}".format(name, repr(getattr(self, name))) for name in self.__slots__))

    def __eq__(self, other: object) -> bool:
        if not isinstance(other, index_t):
            return NotImplemented
        return (
            (self.storage_dim==other.storage_dim) and
            (self.tangent_dim==other.tangent_dim) and
            (self.entries==other.entries)
        )
    # Disallow hashing for python struct lcmtypes.
    __hash__ = None  # type: ignore[assignment]

    def encode(self) -> bytes:
        buf = BytesIO()
        buf.write(index_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf: T.BinaryIO) -> None:
        buf.write(index_t._CACHED_STRUCT_0.pack(self.storage_dim, self.tangent_dim))
        v_num_entries = len(self.entries)
        buf.write(index_t._CACHED_STRUCT_1.pack(v_num_entries))
        for i0 in range(v_num_entries):
            if hasattr(self.entries[i0], '_get_packed_fingerprint'):
                assert self.entries[i0]._get_packed_fingerprint() == index_entry_t._get_packed_fingerprint()
            else:
                assert self.entries[i0]._get_hash_recursive([]) == index_entry_t._get_hash_recursive([])
            self.entries[i0]._encode_one(buf)

    @staticmethod
    def decode(data: T.Union[bytes, T.BinaryIO]) -> "index_t":
        # NOTE(eric): This function can technically accept either a BinaryIO or
        # anything that supports the C++ Buffer Protocol,
        # which is unspecifiable in type hints.

        if hasattr(data, "read"):
            # NOTE(eric): mypy isn't able to figure out the hasattr check
            buf = T.cast(T.BinaryIO, data)
        else:
            buf = BytesIO(T.cast(bytes, data))

        if buf.read(8) != index_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return index_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf: T.BinaryIO) -> "index_t":
        self = index_t(_skip_initialize=True)
        self.storage_dim, self.tangent_dim = index_t._CACHED_STRUCT_0.unpack(buf.read(8))
        v_num_entries = index_t._CACHED_STRUCT_1.unpack(buf.read(4))[0]
        self.entries = []
        for i0 in range(v_num_entries):
            self.entries.append(index_entry_t._decode_one(buf))
        return self

    @staticmethod
    def _get_hash_recursive(parents: T.List[T.Type]) -> int:
        if index_t in parents: return 0
        newparents = parents + [index_t]
        tmphash = (0xcab1ff73ad10c21e+ index_entry_t._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash

    _packed_fingerprint: T.Optional[bytes] = None

    @staticmethod
    def _get_packed_fingerprint() -> bytes:
        if index_t._packed_fingerprint is None:
            index_t._packed_fingerprint = struct.pack(">Q", index_t._get_hash_recursive([]))
        return index_t._packed_fingerprint

    def deepcopy(self, **kwargs: T.Any) -> "index_t":
        """
        Deep copy of this LCM type

        Returns a copy w/ members specified by kwargs replaced with new values specified by kwargs.
        """
        result = copy.deepcopy(self)
        for key in kwargs:
            if not hasattr(result, key):
                raise KeyError("Type index_t does not have attribute: " + str(key))
            setattr(result, key, kwargs[key])
        return result

    _CACHED_STRUCT_0 = struct.Struct(">ii")
    _CACHED_STRUCT_1 = struct.Struct(">i")
