# This file automatically generated by skymarshal
# DO NOT MODIFY BY HAND
# fmt: off
# isort: off
# mypy: disallow-untyped-defs
#
# From Source File: /Users/runner/work/symforce/symforce/lcmtypes/symforce.lcm

import copy
import typing as T  # pylint: disable=unused-import

from io import BytesIO
import struct

class linearization_dense_key_helper_t(object):
    __slots__: T.List[str] = ["factor_offset", "combined_offset", "tangent_dim", "jacobian_storage_col_starts", "hessian_storage_col_starts"]

    def __init__(
        self,
        factor_offset: int=0,
        combined_offset: int=0,
        tangent_dim: int=0,
        jacobian_storage_col_starts: T.Optional[T.Sequence[int]]=None,
        hessian_storage_col_starts: T.Optional[T.Sequence[int]]=None,
        _skip_initialize: bool=False,
    ) -> None:
        """ If _skip_initialize is True, all other constructor arguments are ignored """
        if _skip_initialize:
            return
        # Offset of this key within the factor's state vector
        self.factor_offset: int = factor_offset
        # Offset of this key within the whole problem's state vector
        self.combined_offset: int = combined_offset
        # Tangent dimension of the key
        self.tangent_dim: int = tangent_dim
        self.jacobian_storage_col_starts: T.Sequence[int] = [] if jacobian_storage_col_starts is None else jacobian_storage_col_starts
        self.hessian_storage_col_starts: T.Sequence[int] = [] if hessian_storage_col_starts is None else hessian_storage_col_starts

    @staticmethod
    def from_all_fields(
        factor_offset: int,
        combined_offset: int,
        tangent_dim: int,
        jacobian_storage_col_starts: T.Sequence[int],
        hessian_storage_col_starts: T.Sequence[int],
    ) -> "linearization_dense_key_helper_t":
        return linearization_dense_key_helper_t(
            factor_offset=factor_offset,
            combined_offset=combined_offset,
            tangent_dim=tangent_dim,
            jacobian_storage_col_starts=jacobian_storage_col_starts,
            hessian_storage_col_starts=hessian_storage_col_starts,
        )

    @staticmethod
    def _skytype_meta() -> T.Dict[str, str]:
        return dict(
            type="struct",
            package="sym",
            name="linearization_dense_key_helper_t",
        )

    @classmethod
    def _default(cls) -> "linearization_dense_key_helper_t":
        return cls()

    def __repr__(self) -> str:
        return "linearization_dense_key_helper_t({})".format(
            ", ".join("{}={}".format(name, repr(getattr(self, name))) for name in self.__slots__))

    def __eq__(self, other: object) -> bool:
        if not isinstance(other, linearization_dense_key_helper_t):
            return NotImplemented
        return (
            (self.factor_offset==other.factor_offset) and
            (self.combined_offset==other.combined_offset) and
            (self.tangent_dim==other.tangent_dim) and
            (self.jacobian_storage_col_starts==other.jacobian_storage_col_starts) and
            (self.hessian_storage_col_starts==other.hessian_storage_col_starts)
        )
    # Disallow hashing for python struct lcmtypes.
    __hash__ = None  # type: ignore[assignment]

    def encode(self) -> bytes:
        buf = BytesIO()
        buf.write(linearization_dense_key_helper_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf: T.BinaryIO) -> None:
        buf.write(linearization_dense_key_helper_t._CACHED_STRUCT_0.pack(self.factor_offset, self.combined_offset, self.tangent_dim))
        v_num_jacobian_storage_col_starts = len(self.jacobian_storage_col_starts)
        buf.write(linearization_dense_key_helper_t._CACHED_STRUCT_1.pack(v_num_jacobian_storage_col_starts))
        buf.write(struct.pack('>%di' % v_num_jacobian_storage_col_starts, *self.jacobian_storage_col_starts[:v_num_jacobian_storage_col_starts]))
        v_num_hessian_storage_col_starts = len(self.hessian_storage_col_starts)
        buf.write(linearization_dense_key_helper_t._CACHED_STRUCT_1.pack(v_num_hessian_storage_col_starts))
        buf.write(struct.pack('>%di' % v_num_hessian_storage_col_starts, *self.hessian_storage_col_starts[:v_num_hessian_storage_col_starts]))

    @staticmethod
    def decode(data: T.Union[bytes, T.BinaryIO]) -> "linearization_dense_key_helper_t":
        # NOTE(eric): This function can technically accept either a BinaryIO or
        # anything that supports the C++ Buffer Protocol,
        # which is unspecifiable in type hints.

        if hasattr(data, "read"):
            # NOTE(eric): mypy isn't able to figure out the hasattr check
            buf = T.cast(T.BinaryIO, data)
        else:
            buf = BytesIO(T.cast(bytes, data))

        if buf.read(8) != linearization_dense_key_helper_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return linearization_dense_key_helper_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf: T.BinaryIO) -> "linearization_dense_key_helper_t":
        self = linearization_dense_key_helper_t(_skip_initialize=True)
        self.factor_offset, self.combined_offset, self.tangent_dim = linearization_dense_key_helper_t._CACHED_STRUCT_0.unpack(buf.read(12))
        v_num_jacobian_storage_col_starts = linearization_dense_key_helper_t._CACHED_STRUCT_1.unpack(buf.read(4))[0]
        self.jacobian_storage_col_starts = struct.unpack('>%di' % v_num_jacobian_storage_col_starts, buf.read(v_num_jacobian_storage_col_starts * 4))
        v_num_hessian_storage_col_starts = linearization_dense_key_helper_t._CACHED_STRUCT_1.unpack(buf.read(4))[0]
        self.hessian_storage_col_starts = struct.unpack('>%di' % v_num_hessian_storage_col_starts, buf.read(v_num_hessian_storage_col_starts * 4))
        return self

    @staticmethod
    def _get_hash_recursive(parents: T.List[T.Type]) -> int:
        if linearization_dense_key_helper_t in parents: return 0
        tmphash = (0x97f1539e7349e5d) & 0xffffffffffffffff
        tmphash = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash

    _packed_fingerprint: T.Optional[bytes] = None

    @staticmethod
    def _get_packed_fingerprint() -> bytes:
        if linearization_dense_key_helper_t._packed_fingerprint is None:
            linearization_dense_key_helper_t._packed_fingerprint = struct.pack(">Q", linearization_dense_key_helper_t._get_hash_recursive([]))
        return linearization_dense_key_helper_t._packed_fingerprint

    def deepcopy(self, **kwargs: T.Any) -> "linearization_dense_key_helper_t":
        """
        Deep copy of this LCM type

        Returns a copy w/ members specified by kwargs replaced with new values specified by kwargs.
        """
        result = copy.deepcopy(self)
        for key in kwargs:
            if not hasattr(result, key):
                raise KeyError("Type linearization_dense_key_helper_t does not have attribute: " + str(key))
            setattr(result, key, kwargs[key])
        return result

    _CACHED_STRUCT_0 = struct.Struct(">iii")
    _CACHED_STRUCT_1 = struct.Struct(">i")
