# This file automatically generated by skymarshal
# DO NOT MODIFY BY HAND
# fmt: off
# isort: off
# mypy: disallow-untyped-defs
#
# From Source File: /Users/runner/work/symforce/symforce/lcmtypes/symforce.lcm

import copy
import typing as T  # pylint: disable=unused-import

from io import BytesIO
import struct

class optimizer_gnc_params_t(object):
    __slots__: T.List[str] = ["gnc_update_min_reduction", "mu_initial", "mu_step", "mu_max"]

    def __init__(
        self,
        gnc_update_min_reduction: float=0.0,
        mu_initial: float=0.0,
        mu_step: float=0.0,
        mu_max: float=0.0,
        _skip_initialize: bool=False,
    ) -> None:
        """ If _skip_initialize is True, all other constructor arguments are ignored """
        if _skip_initialize:
            return
        # The convexity param is stepped each time we early-exit with this threshold.
        self.gnc_update_min_reduction: float = gnc_update_min_reduction
        # Initial mu value.
        self.mu_initial: float = mu_initial
        # Amount to change mu each step.
        # After the previous GNC step has converged, the value of gnc_mu_key will be set to
        # min(mu_previous + mu_step, mu_max).
        # If mu_step <= 0, then the GncOptimizer will behave like an Optimizer; it will iterate to
        # convergence once, with the value of gnc_mu_key set to mu_initial and convergence threshold
        # early_exit_min_reduction.
        self.mu_step: float = mu_step
        # Maximum mu value
        # If mu_initial >= mu_max, the GncOptimizer will behave like an Optimizer; it will iterate to
        # convergence once, with the value of gnc_mu_key set to mu_initial and convergence threshold
        # early_exit_min_reduction.
        self.mu_max: float = mu_max

    @staticmethod
    def from_all_fields(
        gnc_update_min_reduction: float,
        mu_initial: float,
        mu_step: float,
        mu_max: float,
    ) -> "optimizer_gnc_params_t":
        return optimizer_gnc_params_t(
            gnc_update_min_reduction=gnc_update_min_reduction,
            mu_initial=mu_initial,
            mu_step=mu_step,
            mu_max=mu_max,
        )

    @staticmethod
    def _skytype_meta() -> T.Dict[str, str]:
        return dict(
            type="struct",
            package="sym",
            name="optimizer_gnc_params_t",
        )

    @classmethod
    def _default(cls) -> "optimizer_gnc_params_t":
        return cls()

    def __repr__(self) -> str:
        return "optimizer_gnc_params_t({})".format(
            ", ".join("{}={}".format(name, repr(getattr(self, name))) for name in self.__slots__))

    def __eq__(self, other: object) -> bool:
        if not isinstance(other, optimizer_gnc_params_t):
            return NotImplemented
        return (
            (self.gnc_update_min_reduction==other.gnc_update_min_reduction) and
            (self.mu_initial==other.mu_initial) and
            (self.mu_step==other.mu_step) and
            (self.mu_max==other.mu_max)
        )
    # Disallow hashing for python struct lcmtypes.
    __hash__ = None  # type: ignore[assignment]

    def encode(self) -> bytes:
        buf = BytesIO()
        buf.write(optimizer_gnc_params_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf: T.BinaryIO) -> None:
        buf.write(optimizer_gnc_params_t._CACHED_STRUCT_0.pack(self.gnc_update_min_reduction, self.mu_initial, self.mu_step, self.mu_max))

    @staticmethod
    def decode(data: T.Union[bytes, T.BinaryIO]) -> "optimizer_gnc_params_t":
        # NOTE(eric): This function can technically accept either a BinaryIO or
        # anything that supports the C++ Buffer Protocol,
        # which is unspecifiable in type hints.

        if hasattr(data, "read"):
            # NOTE(eric): mypy isn't able to figure out the hasattr check
            buf = T.cast(T.BinaryIO, data)
        else:
            buf = BytesIO(T.cast(bytes, data))

        if buf.read(8) != optimizer_gnc_params_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return optimizer_gnc_params_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf: T.BinaryIO) -> "optimizer_gnc_params_t":
        self = optimizer_gnc_params_t(_skip_initialize=True)
        self.gnc_update_min_reduction, self.mu_initial, self.mu_step, self.mu_max = optimizer_gnc_params_t._CACHED_STRUCT_0.unpack(buf.read(32))
        return self

    @staticmethod
    def _get_hash_recursive(parents: T.List[T.Type]) -> int:
        if optimizer_gnc_params_t in parents: return 0
        tmphash = (0x6f04d890c254bb7a) & 0xffffffffffffffff
        tmphash = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash

    _packed_fingerprint: T.Optional[bytes] = None

    @staticmethod
    def _get_packed_fingerprint() -> bytes:
        if optimizer_gnc_params_t._packed_fingerprint is None:
            optimizer_gnc_params_t._packed_fingerprint = struct.pack(">Q", optimizer_gnc_params_t._get_hash_recursive([]))
        return optimizer_gnc_params_t._packed_fingerprint

    def deepcopy(self, **kwargs: T.Any) -> "optimizer_gnc_params_t":
        """
        Deep copy of this LCM type

        Returns a copy w/ members specified by kwargs replaced with new values specified by kwargs.
        """
        result = copy.deepcopy(self)
        for key in kwargs:
            if not hasattr(result, key):
                raise KeyError("Type optimizer_gnc_params_t does not have attribute: " + str(key))
            setattr(result, key, kwargs[key])
        return result

    _CACHED_STRUCT_0 = struct.Struct(">dddd")
