# This file automatically generated by skymarshal
# DO NOT MODIFY BY HAND
# fmt: off
# isort: off
# mypy: disallow-untyped-defs
#
# From Source File: /Users/runner/work/symforce/symforce/lcmtypes/symforce.lcm

import copy
import typing as T  # pylint: disable=unused-import

from io import BytesIO
import struct
from lcmtypes.eigen_lcm._VectorXi import VectorXi

class sparse_matrix_structure_t(object):
    __slots__: T.List[str] = ["row_indices", "column_pointers", "shape"]

    def __init__(
        self,
        row_indices: T.Optional[VectorXi]=None,
        column_pointers: T.Optional[VectorXi]=None,
        shape: T.Optional[T.List[int]]=None,
        _skip_initialize: bool=False,
    ) -> None:
        """ If _skip_initialize is True, all other constructor arguments are ignored """
        if _skip_initialize:
            return
        # The row for each nonzero entry in the matrix
        # size nnz
        self.row_indices: VectorXi = VectorXi._default() if row_indices is None else row_indices
        # The index into row_indices (and the values) of the start of each column
        # size N
        self.column_pointers: VectorXi = VectorXi._default() if column_pointers is None else column_pointers
        self.shape: T.List[int] = [ 0 for dim0 in range(2) ] if shape is None else shape

    @staticmethod
    def from_all_fields(
        row_indices: VectorXi,
        column_pointers: VectorXi,
        shape: T.List[int],
    ) -> "sparse_matrix_structure_t":
        return sparse_matrix_structure_t(
            row_indices=row_indices,
            column_pointers=column_pointers,
            shape=shape,
        )

    @staticmethod
    def _skytype_meta() -> T.Dict[str, str]:
        return dict(
            type="struct",
            package="sym",
            name="sparse_matrix_structure_t",
        )

    @classmethod
    def _default(cls) -> "sparse_matrix_structure_t":
        return cls()

    def __repr__(self) -> str:
        return "sparse_matrix_structure_t({})".format(
            ", ".join("{}={}".format(name, repr(getattr(self, name))) for name in self.__slots__))

    def __eq__(self, other: object) -> bool:
        if not isinstance(other, sparse_matrix_structure_t):
            return NotImplemented
        return (
            (self.row_indices==other.row_indices) and
            (self.column_pointers==other.column_pointers) and
            (self.shape==other.shape)
        )
    # Disallow hashing for python struct lcmtypes.
    __hash__ = None  # type: ignore[assignment]

    def encode(self) -> bytes:
        buf = BytesIO()
        buf.write(sparse_matrix_structure_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf: T.BinaryIO) -> None:
        if hasattr(self.row_indices, '_get_packed_fingerprint'):
            assert self.row_indices._get_packed_fingerprint() == VectorXi._get_packed_fingerprint()
        else:
            assert self.row_indices._get_hash_recursive([]) == VectorXi._get_hash_recursive([])
        self.row_indices._encode_one(buf)
        if hasattr(self.column_pointers, '_get_packed_fingerprint'):
            assert self.column_pointers._get_packed_fingerprint() == VectorXi._get_packed_fingerprint()
        else:
            assert self.column_pointers._get_hash_recursive([]) == VectorXi._get_hash_recursive([])
        self.column_pointers._encode_one(buf)
        buf.write(sparse_matrix_structure_t._CACHED_STRUCT_0.pack(*self.shape[:2]))

    @staticmethod
    def decode(data: T.Union[bytes, T.BinaryIO]) -> "sparse_matrix_structure_t":
        # NOTE(eric): This function can technically accept either a BinaryIO or
        # anything that supports the C++ Buffer Protocol,
        # which is unspecifiable in type hints.

        if hasattr(data, "read"):
            # NOTE(eric): mypy isn't able to figure out the hasattr check
            buf = T.cast(T.BinaryIO, data)
        else:
            buf = BytesIO(T.cast(bytes, data))

        if buf.read(8) != sparse_matrix_structure_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return sparse_matrix_structure_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf: T.BinaryIO) -> "sparse_matrix_structure_t":
        self = sparse_matrix_structure_t(_skip_initialize=True)
        self.row_indices = VectorXi._decode_one(buf)
        self.column_pointers = VectorXi._decode_one(buf)
        self.shape = list(sparse_matrix_structure_t._CACHED_STRUCT_0.unpack(buf.read(16)))
        return self

    @staticmethod
    def _get_hash_recursive(parents: T.List[T.Type]) -> int:
        if sparse_matrix_structure_t in parents: return 0
        newparents = parents + [sparse_matrix_structure_t]
        tmphash = (0x5de55f243244b8ac+ VectorXi._get_hash_recursive(newparents)+ VectorXi._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash

    _packed_fingerprint: T.Optional[bytes] = None

    @staticmethod
    def _get_packed_fingerprint() -> bytes:
        if sparse_matrix_structure_t._packed_fingerprint is None:
            sparse_matrix_structure_t._packed_fingerprint = struct.pack(">Q", sparse_matrix_structure_t._get_hash_recursive([]))
        return sparse_matrix_structure_t._packed_fingerprint

    def deepcopy(self, **kwargs: T.Any) -> "sparse_matrix_structure_t":
        """
        Deep copy of this LCM type

        Returns a copy w/ members specified by kwargs replaced with new values specified by kwargs.
        """
        result = copy.deepcopy(self)
        for key in kwargs:
            if not hasattr(result, key):
                raise KeyError("Type sparse_matrix_structure_t does not have attribute: " + str(key))
            setattr(result, key, kwargs[key])
        return result

    _CACHED_STRUCT_0 = struct.Struct(">2q")
