// -----------------------------------------------------------------------------
// This file was autogenerated by symforce from template:
//     sym_type_casters.h.jinja
// Do NOT modify by hand.
// -----------------------------------------------------------------------------

/* ----------------------------------------------------------------------------
 * SymForce - Copyright 2022, Skydio, Inc.
 * This source code is under the Apache 2.0 license found in the LICENSE file.
 * ---------------------------------------------------------------------------- */

// -----------------------------------------------------------------------------
// Defines template specializations of pybind11::detail::type_caster<T> for
// Geo and Cam types
//
// Must be included in any file using pybind11 to wrap functions whose argument
// types or return types are any of the above geometric types.
// -----------------------------------------------------------------------------

// IWYU pragma: always_keep

#pragma once

#include <fmt/format.h>
#include <pybind11/pybind11.h>
#include <pybind11/stl.h>

#include <sym/atan_camera_cal.h>
#include <sym/double_sphere_camera_cal.h>
#include <sym/equirectangular_camera_cal.h>
#include <sym/linear_camera_cal.h>
#include <sym/ops/storage_ops.h>
#include <sym/orthographic_camera_cal.h>
#include <sym/polynomial_camera_cal.h>
#include <sym/pose2.h>
#include <sym/pose3.h>
#include <sym/rot2.h>
#include <sym/rot3.h>
#include <sym/spherical_camera_cal.h>
#include <sym/unit3.h>

namespace py = pybind11;

namespace pybind11 {
namespace detail {

// based on pybind11/cast.h:783
template <typename T>
struct handle_sym_type_name {
  static constexpr auto name = _("");
};

template <>
struct handle_sym_type_name<sym::Rot2d> {
  static constexpr auto name = _("sym.Rot2");
};

template <>
struct handle_sym_type_name<sym::Rot2f> {
  static constexpr auto name = _("sym.Rot2");
};

template <>
struct handle_sym_type_name<sym::Rot3d> {
  static constexpr auto name = _("sym.Rot3");
};

template <>
struct handle_sym_type_name<sym::Rot3f> {
  static constexpr auto name = _("sym.Rot3");
};

template <>
struct handle_sym_type_name<sym::Pose2d> {
  static constexpr auto name = _("sym.Pose2");
};

template <>
struct handle_sym_type_name<sym::Pose2f> {
  static constexpr auto name = _("sym.Pose2");
};

template <>
struct handle_sym_type_name<sym::Pose3d> {
  static constexpr auto name = _("sym.Pose3");
};

template <>
struct handle_sym_type_name<sym::Pose3f> {
  static constexpr auto name = _("sym.Pose3");
};

template <>
struct handle_sym_type_name<sym::Unit3d> {
  static constexpr auto name = _("sym.Unit3");
};

template <>
struct handle_sym_type_name<sym::Unit3f> {
  static constexpr auto name = _("sym.Unit3");
};

template <>
struct handle_sym_type_name<sym::ATANCameraCald> {
  static constexpr auto name = _("sym.ATANCameraCal");
};

template <>
struct handle_sym_type_name<sym::ATANCameraCalf> {
  static constexpr auto name = _("sym.ATANCameraCal");
};

template <>
struct handle_sym_type_name<sym::DoubleSphereCameraCald> {
  static constexpr auto name = _("sym.DoubleSphereCameraCal");
};

template <>
struct handle_sym_type_name<sym::DoubleSphereCameraCalf> {
  static constexpr auto name = _("sym.DoubleSphereCameraCal");
};

template <>
struct handle_sym_type_name<sym::EquirectangularCameraCald> {
  static constexpr auto name = _("sym.EquirectangularCameraCal");
};

template <>
struct handle_sym_type_name<sym::EquirectangularCameraCalf> {
  static constexpr auto name = _("sym.EquirectangularCameraCal");
};

template <>
struct handle_sym_type_name<sym::LinearCameraCald> {
  static constexpr auto name = _("sym.LinearCameraCal");
};

template <>
struct handle_sym_type_name<sym::LinearCameraCalf> {
  static constexpr auto name = _("sym.LinearCameraCal");
};

template <>
struct handle_sym_type_name<sym::PolynomialCameraCald> {
  static constexpr auto name = _("sym.PolynomialCameraCal");
};

template <>
struct handle_sym_type_name<sym::PolynomialCameraCalf> {
  static constexpr auto name = _("sym.PolynomialCameraCal");
};

template <>
struct handle_sym_type_name<sym::SphericalCameraCald> {
  static constexpr auto name = _("sym.SphericalCameraCal");
};

template <>
struct handle_sym_type_name<sym::SphericalCameraCalf> {
  static constexpr auto name = _("sym.SphericalCameraCal");
};

template <>
struct handle_sym_type_name<sym::OrthographicCameraCald> {
  static constexpr auto name = _("sym.OrthographicCameraCal");
};

template <>
struct handle_sym_type_name<sym::OrthographicCameraCalf> {
  static constexpr auto name = _("sym.OrthographicCameraCal");
};

// type_caster is what does the conversions between python types and C++ types. Needed
// for custom conversions (which we need for the geo types, since we're not using the wrapper)
template <typename T>
struct sym_type_caster {
  PYBIND11_TYPE_CASTER(T, handle_sym_type_name<T>::name);

  static constexpr const char* const kClassName = &handle_sym_type_name<T>::name.text[4];

  sym_type_caster() : value(T::DataVec::Zero()) {}

  bool load(const handle src, bool /* implicit_conversion */) {
    // Converts src (a thin wrapper of a PyObject*) to a T, and assigns to value (a member of the
    // class declared by PYBIND11_TYPE_CASTER)
    if (!py::isinstance(src, py::module_::import("sym").attr(kClassName))) {
      return false;
    }
    const std::vector<typename T::Scalar> data_vec =
        src.attr("to_storage")().cast<std::vector<typename T::Scalar>>();
    value =
        T(Eigen::Matrix<typename T::Scalar, sym::StorageOps<T>::StorageDim(), 1>(data_vec.data()));
    return true;
  }

  static handle cast(const T src, return_value_policy /* policy */, handle /* parent */) {
    // Constructs and returns a py::object representing the same data as src
    constexpr auto storage_dim = sym::StorageOps<T>::StorageDim();
    py::list list(storage_dim);
    const auto data = src.Data();
    for (int i = 0; i < storage_dim; i++) {
      list[i] = data[i];
    }
    const py::object from_storage =
        py::module_::import("sym").attr(kClassName).attr("from_storage");
    py::object result = from_storage(list);
    return result.release();
  }
};

// Defining type_caster<T> for the sym types
template <>
struct type_caster<sym::Rot2d> : public sym_type_caster<sym::Rot2d> {};
template <>
struct type_caster<sym::Rot2f> : public sym_type_caster<sym::Rot2f> {};
template <>
struct type_caster<sym::Rot3d> : public sym_type_caster<sym::Rot3d> {};
template <>
struct type_caster<sym::Rot3f> : public sym_type_caster<sym::Rot3f> {};
template <>
struct type_caster<sym::Pose2d> : public sym_type_caster<sym::Pose2d> {};
template <>
struct type_caster<sym::Pose2f> : public sym_type_caster<sym::Pose2f> {};
template <>
struct type_caster<sym::Pose3d> : public sym_type_caster<sym::Pose3d> {};
template <>
struct type_caster<sym::Pose3f> : public sym_type_caster<sym::Pose3f> {};
template <>
struct type_caster<sym::Unit3d> : public sym_type_caster<sym::Unit3d> {};
template <>
struct type_caster<sym::Unit3f> : public sym_type_caster<sym::Unit3f> {};
template <>
struct type_caster<sym::ATANCameraCald> : public sym_type_caster<sym::ATANCameraCald> {};
template <>
struct type_caster<sym::ATANCameraCalf> : public sym_type_caster<sym::ATANCameraCalf> {};
template <>
struct type_caster<sym::DoubleSphereCameraCald>
    : public sym_type_caster<sym::DoubleSphereCameraCald> {};
template <>
struct type_caster<sym::DoubleSphereCameraCalf>
    : public sym_type_caster<sym::DoubleSphereCameraCalf> {};
template <>
struct type_caster<sym::EquirectangularCameraCald>
    : public sym_type_caster<sym::EquirectangularCameraCald> {};
template <>
struct type_caster<sym::EquirectangularCameraCalf>
    : public sym_type_caster<sym::EquirectangularCameraCalf> {};
template <>
struct type_caster<sym::LinearCameraCald> : public sym_type_caster<sym::LinearCameraCald> {};
template <>
struct type_caster<sym::LinearCameraCalf> : public sym_type_caster<sym::LinearCameraCalf> {};
template <>
struct type_caster<sym::PolynomialCameraCald> : public sym_type_caster<sym::PolynomialCameraCald> {
};
template <>
struct type_caster<sym::PolynomialCameraCalf> : public sym_type_caster<sym::PolynomialCameraCalf> {
};
template <>
struct type_caster<sym::SphericalCameraCald> : public sym_type_caster<sym::SphericalCameraCald> {};
template <>
struct type_caster<sym::SphericalCameraCalf> : public sym_type_caster<sym::SphericalCameraCalf> {};
template <>
struct type_caster<sym::OrthographicCameraCald>
    : public sym_type_caster<sym::OrthographicCameraCald> {};
template <>
struct type_caster<sym::OrthographicCameraCalf>
    : public sym_type_caster<sym::OrthographicCameraCalf> {};

}  // namespace detail
}  // namespace pybind11
